#include<bits/stdc++.h>

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    long long n, q;
    cin >> n >> q;
    vector<long long> d(n), p(n);
    vector<long long> h(q);
    for(int i=0;i<n;i++) {
        cin >> d[i] >> p[i];
    }
    for(int i=0;i<q;i++) {
        cin >> h[i];
    }
    for(int i=0; i<n; i++) {
        long long z=0;
        int br=0;

        for(int j=0; j<q; j++) {
                //z+=p[j];
                //cout << z << ". ";
            h[i] -= d[j];
        //h[i]-=z;
        br++;
        if(h[i]<=0) {
            h[i] += d[j];
            //h[i] +=z;
            if(h[i] ==0 ){
                cout << br << endl;
                j=q;
            }
            else {
                cout << "-1" << endl;
                j=q;
            }
        }
        else {
            cout << "-1" << endl;
        }
        }
        //cout << h[i] << " ";
        //cout<<"Next:'"<<endl;
    }
    return 0;
}